# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .device_capabilities_supported_item import DeviceCapabilitiesSupportedItem
from .device_device_type import DeviceDeviceType
from .device_errors_item import DeviceErrorsItem
from .device_properties import DeviceProperties
from .device_warnings_item import DeviceWarningsItem


class Device(pydantic.BaseModel):
    device_id: str
    device_type: DeviceDeviceType
    capabilities_supported: typing.List[DeviceCapabilitiesSupportedItem]
    properties: DeviceProperties
    location: typing.Optional[typing.Any]
    connected_account_id: str
    workspace_id: str
    errors: typing.List[DeviceErrorsItem]
    warnings: typing.List[DeviceWarningsItem]
    created_at: dt.datetime
    is_managed: str

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
